<template>
  <main class="HomeView">
    <h2 class="HomeView__Title">{{ t('entries.running') }}</h2>
    <ol class="HomeView__Entries GroupEntries__Running">
      <Skeleton v-if="loadingRunning" class="HomeView__Loader" />
      <Skeleton v-if="loadingRunning" class="HomeView__Loader" />
      <EntryBlock
        v-for="id in runningIDs"
        :id="id"
        :key="id"
        tag="li"
        @removed="isRemoved"
        class="HomeView__Entry"
      />
    </ol>
    <h2 class="HomeView__Title">{{ t('entries.ended') }}</h2>
    <ol class="HomeView__Entries GroupEntries__Stopped">
      <EntryBlock
        v-for="id in stoppedIds"
        :id="id"
        :key="id"
        tag="li"
        @removed="isRemoved"
        class="HomeView__Entry"
      />
    </ol>
    <ScrollTop
      target="parent"
      :threshold="100"
      class="HomeView__ScrollTop"
      icon="pi pi-arrow-up"
    />

    <Observer @intersect="intersected" v-if="observe">
      <Skeleton class="HomeView__Loader" />
    </Observer>
    <Skeleton v-if="!endReached" class="HomeView__Loader" />
    <Skeleton v-if="!endReached" class="HomeView__Loader" />
    <Skeleton v-if="!endReached" class="HomeView__Loader" />

    <span v-if="endReached">End</span>
  </main>
</template>

<script lang="ts">
import {
  computed,
  defineComponent,
  nextTick,
  onMounted,
  onUnmounted,
  reactive,
  ref,
} from 'vue'
import { Icons } from '@/Icons'
import { Entries } from '@/stores'
import EntryBlock from './partial/EntryBlock.vue'
import { Entry } from '@/types'
import { useTranslation } from '@/components/UseTranslation'
import { Observer } from '@/components'

type SortedEntries = Map<Entry['id'], Entry>

const compareStart = (e1: Entry, e2: Entry) =>
  e2.start.valueOf() - e1.start.valueOf()

export default defineComponent({
  name: 'Home',
  components: { EntryBlock, Observer },

  setup() {
    const entries = reactive<SortedEntries>(new Map<Entry['id'], Entry>())

    function isRemoved(id: Entry['id']) {
      entries.delete(id)
    }

    const observer = Entries.Observer.createStoreObserver({
      methods: {
        onPut: (event) => {
          entries.set(event.payload.id, event.payload)
        },
        onDelete: (event) => {
          isRemoved(event.id)
        },
      },
    })
    observer.start()
    onUnmounted(() => observer.stop())

    const endReached = ref<boolean>(false)

    /**
     * Laods the next stopped entries
     * returns date of last entry load, false if end of list is reached
     * @param after
     */
    async function loadNextStoppedEntries(
      after?: Date
    ): Promise<Date | undefined> {
      const store = await Entries.storeRead()
      let stopCount = 0
      for await (const cursor of store
        .index('by-stop')
        .iterate(after ? IDBKeyRange.upperBound(after) : undefined, 'prev')) {
        if (cursor.value && cursor.value.stop) {
          entries.set(cursor.value.id, cursor.value)
          stopCount++
          if (stopCount >= 5) {
            return cursor.value.stop
          }
        }
      }

      endReached.value = true
      return undefined
    }

    let after: Date | undefined = undefined

    const loadingRunning = ref<boolean>(true)

    onMounted(async () => {
      loadingRunning.value = true
      const store = await Entries.storeRead()
      for await (const cursor of store
        .index('by-duration')
        .iterate(-1, 'next')) {
        if (cursor.value) {
          entries.set(cursor.value.id, cursor.value)
        }
      }
      loadingRunning.value = false
    })

    const loadNextTimeout = ref<number>(0)

    const intersected = (intersecting: boolean) => {
      if (loadNextTimeout.value || !intersecting) return
      loadNextTimeout.value = window.setTimeout(async () => {
        after = await loadNextStoppedEntries(after)
        await nextTick()
        loadNextTimeout.value = 0
      }, 100)
    }

    return {
      Icons,
      entries,
      runningIDs: computed(() =>
        Array.from(entries.values())
          .filter((e) => !e.stop)
          .sort(compareStart)
          .map((e) => e.id)
      ),
      stoppedIds: computed(() =>
        Array.from(entries.values())
          .filter((e) => !!e.stop)
          .sort(compareStart)
          .map((e) => e.id)
      ),
      isRemoved,
      intersected,
      endReached,
      observe: computed(() => !loadNextTimeout.value && !endReached.value),
      loadingRunning,
      ...useTranslation(),
    }
  },
})
</script>

<style lang="scss" scoped>
@use '../style/variables' as v;
@use '../style/view';

.HomeView {
  @extend .View;

  &__Title {
    align-self: flex-start;
    font-weight: 400;
    font-size: 0.8rem;
  }

  &__Entries {
    display: flex;
    flex-direction: column;
    width: 100%;
    margin: 0;
    padding: 0 0 v.$spacing 0;
  }

  &__Entry {
    margin-bottom: 2px;
    background-color: var(--background-color);
  }

  &__ScrollTop {
    right: 0;
    min-height: 3rem;
  }

  &__Loader {
    width: 100%;
    height: 100px;
    margin-bottom: 2px;
  }
}
</style>
